////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////
// SE-UFND4 DEMO PROGRAM
//
// Arduino/Raspberry Pi 에서 시리얼 통신포트(TxD)를 통하여 출력하는 시리얼 
// 데이터를 수신하여 4개 문자를 4개의 디지트에 표시합니다.
// 문자열은 최대 16문자와 개행코드(ASCII Code CR(0x0d))로 구성되어야 합니다.
// "0" 부터 "9" 까지의 숫자와 마이너스부호 "-" 그리고 소소점 "."을 표시하지만
// 7 세그멘트에서 표시 가능한 알파벳 문자/기호의 표시가 가능합니다.
// 소소점은 단독 디지트로 표시하지 않고 이전 문자와 같이 중첩하여 표시됩니다.
//
// 4개이상의 문자(CR 코드, 소수점)는 문자열에서 오른쪽 4 문자를 제외한 나머지
// 상위문자에 CR 코드를 첨부하여 내보내며 상위 모듈은 이 문자열을 받아
// 표시합니다.
//
// DEC, 20 2015  V1.0
// DEC. 31 2015  V1.1
//
// WWW.ARDUINOPLUS.CC
////////////////////////////////////////////////////////////////////

float fdata;
long int idata;
char* myString = "-0.123456789 ABCD";
char buffer[20];

void setup() {
  // initialize serial communications at 9600 bps:
  Serial.begin(9600); 
}

void loop() {
  
// Clear FND
  Serial.println(); // 개행코드(CR)는 FND를 클리어 합니다.
  delay(1000);
///////////////////////////////////////  
  idata = -1; Serial.println(idata); delay(500);
  idata = -12; Serial.println(idata); delay(500);
  idata = -123; Serial.println(idata); delay(500);
  idata = -1234; Serial.println(idata); delay(500);
  idata = -12345; Serial.println(idata); delay(500);
  idata = -123456; Serial.println(idata); delay(500);
  idata = -1234567; Serial.println(idata); delay(500);
  idata = -12345678; Serial.println(idata); delay(500);
  idata = -123456789; Serial.println(idata); delay(500);
  idata = -1234567890; Serial.println(idata); delay(500);
  Serial.print(idata); Serial.println(" "); delay(500);
  Serial.print(idata); Serial.println("  "); delay(500);
  Serial.print(idata); Serial.println("   "); delay(500);
  Serial.print(idata); Serial.println("    "); delay(1500);

// Randon Number  
  for (int i = 0; i<10; i++) {  
    Serial.println(random(9999)); delay(200);
  }
  
//  MAX Unsigned Long Integer
//  Serial.println(4294967295);   // 2^32-1
  delay(1500);
  
// https://www.arduino.cc/en/Serial/Print  
// println();은 십진수(DEC), 이진수(BIN), 8진수(OCT), 16진수(HEX)의 형식으로 출력가능합니다.
  Serial.println(78, DEC); delay(1500); // gives "78"
  Serial.println(78, BIN); delay(1500); // gives "1001110"
  Serial.println(78, OCT); delay(1500); // gives "116"
  Serial.println(78, HEX); delay(1500); // gives "4E"
// 소소점 수는 소수점 아래의 표시 개수를 지정할 수 있습니다.
  Serial.println(1.23456, 0); delay(1500); // gives "1"
  Serial.println(1.23456, 2); delay(1500); // gives "1.23"
  Serial.println(1.23456, 4); delay(1500); // gives "1.2346"
/////////////////////////////////////////////////////
// 부동 소소점 표현 가능 범위보다 큰 수는 “Ovr” 표시됩니다.
  for(int i = 0; i<=40; i++) {   
     Serial.print(i); 
     Serial.print("= ");
     fdata = pow(2,i);   // 2의 33승 부터 Over가 됩니다.
     Serial.println(fdata); 
     delay(500);
  }
  delay(1500);
//////////////////////////////////
  Serial.println(myString); delay(1500);
  
//// sprintf();를 이용하면 스트링에 저장된 데이터를 표시할 수 있습니다.
//// 수 표현 범위는 16 비트 이내 입니다. 
  idata = 1;      // 1     
  sprintf(buffer,"%d",idata); Serial.println(buffer); delay(1500);
  idata = 65536;  // 0    
  sprintf(buffer,"%d",idata); Serial.println(buffer); delay(1500);
  idata = 65535;  // -1    
  sprintf(buffer,"%d",idata); Serial.println(buffer); delay(1500);
  idata = 65534;  // -2    
  sprintf(buffer,"%d",idata); Serial.println(buffer); delay(1500);
  idata = 32769;  // -32767    
  sprintf(buffer,"%d",idata); Serial.println(buffer); delay(1500);
  idata = 32768;  // -32768    
  sprintf(buffer,"%d",idata); Serial.println(buffer); delay(1500);
  idata = 32767;  // 32767    
  sprintf(buffer,"%d",idata); Serial.println(buffer); delay(1500);
  
//// 십진수(DEC), 8진수(OCT), 16진수(HEX)의 형식으로 출력가능합니다.
//////////////////////////////////// HEX   
  sprintf(buffer,"%x",0xABCD);    // ABCD
  Serial.println(buffer);
  delay(1500);
  
  sprintf(buffer,"%x",65535);     // 0xFFFF
  Serial.println(buffer);
  delay(1500);
//////////////////////////////////// OCTAL     
  sprintf(buffer,"%o",0123);      // Octal 123
  Serial.println(buffer);
  delay(1500);
//////////////////////////////////
// sprintf(); 은 소수점 수를 지원하지 않습니다. 
// 아래 예는 컴파일 에러는 발생하지 않지만 “?” 표시됩니다.
  fdata = 1.234567;
  sprintf(buffer,"%f", fdata);   Serial.println(buffer);  // ?
  delay(1500); 
////////////////////////////////// CLOCK Data
// sprintf();는 형식 문자열(formated string)을 지원합니다.
// 표시 수가 5자리를 가지고 싶으면 "5d"를 지정합니다. 5 자리보다 작은 수는
// 원쪽에 공백문자(space)로 채워집니다. 공백대신 "0"이 채워지기 원하면
// "05d"를 지정합니다.
// 아래의 예는 시계의 시와 분을 표시하는 예입니다. 
// 시간과 분은 같은 2자리로 표시되지만
// 한자리의 시 표시에서 " "을, 한자리의 분 표시에서 "0"이 채워지게 됩니다.
int hour = 3;      // 
int minute = 5;    //
  sprintf(buffer,"t=%2d.%02d",hour, minute);
  Serial.println(buffer);
  delay(2500);

// 표시 가능한 Alpabet Character 
  Serial.println("ABCDEFGHLNOPQRST"); delay(1500);  
  Serial.println("UVY 9876543210."); delay(2500);
  
// 표시 가능한 특수문자(Special Character)
  Serial.println("@-[]=_*~/<>{}()"); delay(1500);
  Serial.println("`%#'^\t? "); delay(2500);
  Serial.println("------END-------"); delay(3500);  
  
}

////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////
