#include <WiFi.h>
#include <WiFiClient.h>
#include "DHT11.h"
#include "PubSubClient.h"
byte server[] = {192,168,0,66};
int port = 1883;
char clientId[64];
char topic[10+1] = {'a','r','d','u','i','n','o','\0'};
char ssid[] = "TA-Edu-AP01";
char password[] = "tw!02194";
int status = WL_IDLE_STATUS;
void msgReceived(char* topic, byte* payload, unsigned int uLen);
//void msgReceived(char* topic, byte* payload, unsigned int uLen);
WiFiClient wifiClient;
PubSubClient client(server, port, msgReceived, wifiClient);
DHT11 dht11(2);//온습도
void setup() {
  Serial.begin(9600);
  if (WiFi.status() == WL_NO_SHIELD) {
    Serial.println("WiFi Shield Error");
    while(true);  
  }
  while(status != WL_CONNECTED) {
    status = WiFi.begin(ssid,password);
    delay(3000);
  }
  Serial.println("Wi-Fi AP Connected");
  sprintf(clientId, "arduino");
  if (client.connect(clientId)) {
    Serial.println("MQTT Server connect!");
    sprintf(topic, "arduino");
    client.subscribe(topic);
    
  }
}
void msgReceived(char* topic, byte* payload, unsigned int uLen) {
//void msgReceived(char* topic, byte* payload, unsigned int uLen) {
  Serial.println("msgReceived!!!!");
  for (int i = 0; i < uLen; i++) Serial.print(payload[i]);
  Serial.println();
}
void loop() {
  // put your main code here, to run repeatedly:
  int error;
    float temp,humidity;
    if ((error = dht11.read(humidity,temp)) == 0) {
      char message[64] = "";
      char pTempBuffer[50];
      dtostrf(temp , 5, 2, pTempBuffer);
      char pHumidityBuffer[50];
      dtostrf(humidity , 5, 2, pHumidityBuffer);
      sprintf(message, "{\"temp\":%s,\"humidity\":%s}", pTempBuffer,pHumidityBuffer);
      client.publish(topic, message);
    }
    delay(1000);
}
